//////////////////////////////////////////////////////////////////////////////////////////////////

entity* eBall;
sound sPong = <tap.wav>;

//////////////////////////////////////////////////////////////////////////////////////////////////

var vSpeed;
var vAngularSpeed;

//////////////////////////////////////////////////////////////////////////////////////////////////

function Kick();
function Plop();

//////////////////////////////////////////////////////////////////////////////////////////////////

function main()
{
	shadow_stencil = on;
	sound_vol = 100;
	level_load ("test.wmb");
	wait (3);
 	eBall = ent_create("earth.mdl", vector(0, 0, 100), null);
	phent_settype (eBall, ph_rigid, ph_sphere);
	phent_setmass (eBall, 1, ph_sphere);
	phent_setfriction (eBall, 90);
	phent_setelasticity (eBall, 75, 100);
	phent_setdamping (eBall, 30, 5);
	phent_addvelcentral (eBall, vector(2, 2, 0));
	ph_setgravity(vector(0, 0, -500));
	eBall.shadow = on;
	eBall.cast = on;
	on_space = Kick;
	eBall.event = Plop;
	eBall.enable_friction = on;
	while (1) 
	{
		var vForce;
		var vMove;
		var iSpeed = 6;
		vForce.x = -5 * (key_force.x + mouse_force.x); // pan angle
		vForce.y = 5 * (key_force.y + mouse_force.y); // tilt angle
		vForce.z = 0; // roll angle
		vec_accelerate (vMove, vAngularSpeed, vForce, 0.8);
		vec_add (camera.pan, vMove);		
		vForce.x = iSpeed * (key_w - key_s); // forward
		vForce.y = iSpeed * (key_a - key_d); // sideward
		vForce.z = iSpeed * (key_home - key_end);	// upward
		vec_accelerate (vMove, vSpeed, vForce, 0.5);
		vec_rotate (vMove, camera.pan);
		vec_add (camera.x, vMove);
		wait(1);
	}
}

function Plop()
{
	ent_playsound(eBall, sPong, 100);
}

function Kick()
{
	var vSpeed;
	vSpeed.x = 150;
	vec_rotate(vSpeed, camera.pan);
	vSpeed.z = 75;
	phent_addvelcentral (eBall, vSpeed);
	Plop();
}
